package javax.management.remote;

import javax.management.ListenerNotFoundException;
import javax.management.NotificationFilter;
import javax.management.NotificationListener;
import javax.security.auth.Subject;
import javax.management.MBeanServerConnection;
import java.util.Map;
import java.io.IOException;
import java.io.Closeable;

public interface JMXConnector extends Closeable
{
    public static final String CREDENTIALS = "jmx.remote.credentials";
    
    public abstract void connect() throws IOException;
    
    public abstract void connect(Map<String, ?> p0) throws IOException;
    
    public abstract MBeanServerConnection getMBeanServerConnection() throws IOException;
    
    public abstract MBeanServerConnection getMBeanServerConnection(Subject p0) throws IOException;
    
    public abstract void close() throws IOException;
    
    public abstract void addConnectionNotificationListener(NotificationListener p0, NotificationFilter p1, Object p2);
    
    public abstract void removeConnectionNotificationListener(NotificationListener p0) throws ListenerNotFoundException;
    
    public abstract void removeConnectionNotificationListener(NotificationListener p0, NotificationFilter p1, Object p2) throws ListenerNotFoundException;
    
    public abstract String getConnectionId() throws IOException;
}
